---
title: 'XRSession: squeezestart event'
slug: Web/API/XRSession/squeezestart_event
tags:
  - API
  - AR
  - Event
  - Input Sources
  - Inputs
  - Mixed
  - Primary Squeeze Actions
  - Reality
  - Reference
  - Squeeze Actions
  - VR
  - Virtual
  - WebXR
  - WebXR API
  - WebXR Device API
  - XR
  - XRSession
  - augmented
  - controllers
  - squeezestart
---
<p>{{APIRef("WebXR Device API")}}{{SecureContext_Header}}</p>

<p><span class="seoSummary">The <a href="/en-US/docs/Web/API/WebXR_Device_API">WebXR</a> event <code><strong>squeezestart</strong></code> is sent to an {{domxref("XRSession")}} when the user begins a <a href="/en-US/docs/Web/API/WebXR_Device_API/Inputs#Primary_squeeze_actions">primary squeeze action</a> on one of its input sources.</span> Primary squeeze actions are actions which are meant to represent gripping or squeezing using your hands, and may be simulated using triggers on hand controllers.</p>

<table class="properties">
 <tbody>
  <tr>
   <th scope="row">Bubbles</th>
   <td>Yes</td>
  </tr>
  <tr>
   <th scope="row">Cancelable</th>
   <td>No</td>
  </tr>
  <tr>
   <th scope="row">Interface</th>
   <td>{{domxref("XRInputSourceEvent")}}</td>
  </tr>
  <tr>
   <th scope="row">Event handler property</th>
   <td>{{domxref("XRSession.onsqueezestart", "onsqueezestart")}}</td>
  </tr>
 </tbody>
</table>

<p>For details on how the {{domxref("XRSession.squeezestart_event", "squeezestart")}}, {{domxref("XRSession.squeeze_event", "squeeze")}}, and {{domxref("XRSession.squeezeend_event", "squeezeend")}} events work, and how you should react to them, see {{SectionOnPage("/en-US/docs/Web/API/WebXR_Device_API/Inputs", "Primary squeeze actions")}}.</p>

<h2 id="Examples">Examples</h2>

<p>The following example uses {{domxref("EventTarget.addEventListener", "addEventListener()")}} to establish handlers for the squeezeion events: {{domxref("XRSession.squeezestart_event", "squeezestart")}}, {{domxref("XRSession.squeezeend_event", "squeezeend")}}, and {{domxref("XRSession.squeeze_event", "squeeze")}}. This snippet is the core of an event handler to allow the user to grab objects in the scene and move them around.</p>

<p>In this case, a single function is used to handle all three events, allowing them to share certain code that's the same regardless of which of the three events is received. Only after completing those tasks does the <code>onSqueezeEvent()</code> function below dispatch the action out to a specialized function to handle things.</p>

<p>After checking to ensure that the received event is a <code>tracked-pointer</code> event (the only kind we handle here), the target ray's pose is obtained using {{domxref("XRFrame.getPose", "getPose()")}}.</p>

<p>If the target ray pose was fetched successfully, the code then uses the value of {{domxref("Event")}} property {{domxref("Event.type", "type")}} to route control to an appropriate function to handle the event which arrived:</p>

<ul>
 <li>For <code>squeezestart</code> events, a <code>myBeginTracking()</code> function is called with the target ray pose's {{domxref("XRRigidTransform.matrix", "matrix")}}. The <code>myBeginTracking()</code> function would presumably start the presentation of the object-dragging process, using the transform to perform a hit test, determining which object to pick up. <code>myBeginTracking()</code> returns an object representing the object the user has begun to drag.</li>
 <li>Upon receiving a <code>squeeze</code> event, the <code>myDropObject()</code> function is called with the target object and the current target ray pose transform as inputs. This places the object into its new position in the world and triggers any effects that may arise from doing so (like scheduling an animation of a splash if dropped in water, etc).</li>
 <li>The <code>squeezeend</code> event results in a <code>myStopTracking()</code> function being called with the object being dragged and the final target ray pose's transform.</li>
</ul>

<pre class="brush: js">xrSession.addEventListener("squeezestart", onSqueezeEvent);
xrSession.addEventListener("squeeze", onSqueezeEvent);
xrSession.addEventListener("squeezeend", onSqueezeEvent);

function onSqueezeEvent(event) {
  let source = event.inputSource;
  let targetObj = null;

  if (source.targetRayMode != "tracked-pointer") {
    return;
  }

  let targetRayPose = event.frame.getPose(source.targetRaySpace, myRefSpace);
  if (!targetRayPose) {
    return;
  }

  switch(event.type) {
    case "squeezestart":
      targetObj = myBeginTracking(targetRayPose.matrix);
      break;
    case "squeeze":
      myDropObject(targetObj, targetRayPose.matrix);
      break;
    case "squeezeend":
      myStopTracking(targetObj, targetRayPose.matrix);
      break;
  }
}
</pre>

<p>You can of course also set up a handler these events by setting the {{domxref("XRSession")}} object's {{domxref("XRSession.onsqueezeend", "onsqueezeend")}} event handler property to a function that handles the event:</p>

<pre class="brush: js">xrSession.onsqueezestart = onSqueezeEvent;
xrSession.onsqueeze = onSqueezeEvent;
xrSession.onsqueezeend = onSqueezeEvent;</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName("WebXR","#eventdef-xrsession-squeezestart","squeezestart event")}}</td>
   <td>{{Spec2("WebXR")}}</td>
   <td>Initial definition.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<div>{{Compat("api.XRSession.squeezestart_event")}}</div>
